      program gaupd                                                       gaupd.2
c dwm                                                                     gaupd.3
c dwm    Version 2.1:  9 February 2006                                    gaupd.4
c dwm    several changes were made (see "c dwm" lines) to resurrect       mar29.5
c dwm    the previously defunct comdeck capability.                       gaupd.6
c dwm                                                                     mar29.7
c dwm    Version 2.2:  27 March 2014                                      mar29.8
c dwm    several additional changes were made (additional "c dwm" lines)  mar29.9
c dwm    to enable the proper processing of updates to comdecks.          mar29.10
c dwm                                                                     gaupd.7
c     ******************************************************************  gaupd.8
c                                                                         gaupd.9
c     A Simple Update Program                            vers: 2.1        gaupd.10
c     for Maintaining FORTRAN Codes                      date: 31 oct 97  gaupd.11
c     -------------------------------                                     gaupd.12
c     To be used with NJOY 97                                             gaupd.13
c                                                                         gaupd.14
c     This program is loosely based on the UPDATE program that runs on    gaupd.15
c     CDC and Cray machines.  It allows you to keep a record of           gaupd.16
c     consecutive changes to a FORTRAN program that is useful for         gaupd.17
c     history and quality assurance purposes.  The changes are            gaupd.18
c     specified with simple commands that are easy to exchange            gaupd.19
c     between various users of a code being maintained with upd.          gaupd.20
c     This is a stripped-down adaptation with only basic capabilities,    gaupd.21
c     but because of that, it is easy to install on any computer system.  gaupd.22
c                                                                         gaupd.23
c     The original FORTRAN source code is stored in the file "src".       gaupd.24
c     It is divided up into separate named parts by "*deck name" lines.   gaupd.25
c     In each named part, the first line after the "*deck" line           gaupd.26
c     is numbered "name.2", the next card is referred to using "name.3",  gaupd.27
c     etc.  The "src" files can also contain "*if", "*elseif", "*else",   gaupd.28
c     and "*endif" lines as described below.  These lines are numbered    gaupd.29
c     just like any other lines in the "src" file.                        gaupd.30
c                                                                         gaupd.31
c     Changes to the FORTRAN code are given in an input file called       gaupd.32
c     "upn".  This file is divided into separate named parts by           gaupd.33
c     "*ident name".  Each "ident" can contain a mixture of upd direc-    gaupd.34
c     tives and new FORTRAN statements. The directives are as follows:    gaupd.35
c                                                                         gaupd.36
c      *i ref                                                             gaupd.37
c          insert the lines between the "*i" directive and the            gaupd.38
c          next upd directive after the location "ref".                   gaupd.39
c                                                                         gaupd.40
c      *b ref                                                             gaupd.41
c          insert the lines between the "*b" directive and the            gaupd.42
c          next upd directive before the location "ref".                  gaupd.43
c                                                                         gaupd.44
c      *d ref1,ref2                                                       gaupd.45
c          delete the lines between "ref1" and "ref2, and                 gaupd.46
c          insert the lines between the "*d" directive and the            gaupd.47
c          next upd directive (if any).                                   gaupd.48
c                                                                         gaupd.49
c     The line references can have the following forms:                   gaupd.50
c                                                                         gaupd.51
c          name.5                                                         gaupd.52
c          name.5,7                                                       gaupd.53
c          name1.5,nampr.6                                                gaupd.54
c                                                                         gaupd.55
c     Updates can be made on top of previous updates as long as           gaupd.56
c     each line referenced is currently active.  Updates are              gaupd.57
c     numbered so that the first line after the "*ident name" line        gaupd.58
c     is labeled "name.2".                                                gaupd.59
c                                                                         gaupd.60
c     Update decks can also contain comments of the form                  gaupd.61
c                                                                         gaupd.62
c          */ text                                                        gaupd.63
c                                                                         gaupd.64
c     Comments are numbered just like other lines in the ident.           gaupd.65
c     They are not written to the output files.  It is recommended        gaupd.66
c     that "*/" comments be used to explain the purpose of each ident     gaupd.67
c     and to give the date of the modification.  As an example,           gaupd.68
c                                                                         gaupd.69
c          */ junkr -- 31oct97                                            gaupd.70
c          */ patch an error in the framous routine in junkr              gaupd.71
c          */ that causes divides by zero on kim-1 computers              gaupd.72
c                                                                         gaupd.73
c     This convention makes it easy to find any patches to a particular   gaupd.74
c     module and to track the dates that the work was done.               gaupd.75
c                                                                         gaupd.76
c     Both decks and update "idents" can contain conditional              gaupd.77
c     statements.  Only the following very basic form is supported:       gaupd.78
c                                                                         gaupd.79
c          *if condition                                                  gaupd.80
c          ...                                                            gaupd.81
c          *elseif condition                                              gaupd.82
c          ...                                                            gaupd.83
c          *else                                                          gaupd.84
c          ...                                                            gaupd.85
c          *endif                                                         gaupd.86
c                                                                         gaupd.87
c     The condition consists of a single word that has been "set"         gaupd.88
c     true with a "*set word" command at the beginning of the upd         gaupd.89
c     input deck.  All words not set are assumed to be false.  These      gaupd.90
c     "if" statements can be nested.                                      gaupd.91
c                                                                         gaupd.92
c     New decks can be added by including a *deck command followed        gaupd.93
c     by the FORTRAN coding in the UPN file.  Deck names must be unique   gaupd.94
c     and must not be the same as any ident name.                         gaupd.95
c                                                                         gaupd.96
c     Comdecks may appear in either the UPN or SRC files.  They are       gaupd.97
c     preceded by a *comdeck command. A *call comdeckname will place      gaupd.98
c     a copy of the comdeck in this location.  Comdecks may be updated    gaupd.99
c     with the normal *i, *b, and *d commands.                            gaupd.100
c                                                                         gaupd.101
c     There are several upd commands that can appear at the               gaupd.102
c     beginning of the upd input deck "upn".  They are as follows:        gaupd.103
c                                                                         gaupd.104
c       *cpl name1,nampr,name3,.....                                      gaupd.105
c          request that the named deck(s) be processed into "cpl"         gaupd.106
c          compiler files.  The files will be written as "name1.f",       gaupd.107
c          "nampr.f", etc.  More than one "*cpl" command can be           gaupd.108
c          included.  Each line on the "cpl" file will have a label of    gaupd.109
c          the form "name.number" starting in column 73.  The name will   gaupd.110
c          be either a deck name or an ident name.  If no deck names      gaupd.111
c          are given, all decks are written to the file "cpl".  If        gaupd.112
c          name1 is "all", all the decks found will be processed into     gaupd.113
c          "name.f" files.  (To change the suffix from .f to something    gaupd.114
c          else, see the variable "suff" in the code).                    gaupd.115
c                                                                         gaupd.116
c       *noid                                                             gaupd.117
c          request that the card identifiers in colums 73-84 be           gaupd.118
c          omitted from all lines of the cpl file.  This is required      gaupd.119
c          for some compilers that cannot handle more than 80 chars       gaupd.120
c          per line.  Use the lst file to determine card labels.          gaupd.121
c                                                                         gaupd.122
c       *npl                                                              gaupd.123
c          request that a new "src" file called "npl" be created          gaupd.124
c          with all the corrections applied.  The "*deck" lines and       gaupd.125
c          the "*if" constructs are included in the file.  No line        gaupd.126
c          number identifiers are given.                                  gaupd.127
c                                                                         gaupd.128
c       *lst name1,nampr,name3,.....                                      gaupd.129
c          request that special "lst" files be prepared containing        gaupd.130
c          a listing of the modified file for each of the named decks.    gaupd.131
c          The files will be written as "name1.lst", nampr.lst", etc.     gaupd.132
c          The listings have the line identifier labels on the left and   gaupd.133
c          program, subroutine, or function names on the right.  If       gaupd.134
c          there are no names, all decks are written to the "lst" file.   gaupd.135
c          If name1 is "all", all decks found will be processed into      gaupd.136
c          "name.lst" files.  All branches of "*if" constructs are        gaupd.137
c          shown on these listing files.                                  gaupd.138
c                                                                         gaupd.139
c       *set word1,word2,.....                                            gaupd.140
c          set a word or words for a "*if" construction to the "true"     gaupd.141
c          state.                                                         gaupd.142
c                                                                         gaupd.143
c     Running upd with the files "src" and "upn" present can generate     gaupd.144
c     a file "cpl" containing the updated FORTRAN code (or a set of       gaupd.145
c     name.f files), an "npl" file suitable for use as a new "src" file,  gaupd.146
c     a "lst" file (or a set of name.lst files), or any combination of    gaupd.147
c     ation of these, depending on which directives appear in "upn".      gaupd.148
c     Note that "npl" is not a binary file as in CDC of CRAY UPDATE       gaupd.149
c     and that no binary "OLDPL" is used in UPD.                          gaupd.150
c                                                                         gaupd.151
c     history...                                                          gaupd.152
c                                                                         gaupd.153
c     1.1     Increased number of active lines allowed to 5000.           gaupd.154
c             Minor cleanup work.                                         gaupd.155
c     1.2     Fixed a problem in deleting a range that started            gaupd.156
c               inside one block and ended inside another.                gaupd.157
c             Added the noid option.                                      gaupd.158
c     1.3     Add comdeck, nested ifs and deck in upn file                gaupd.159
c     1.4     Increased number of active lines to 9999                    gaupd.160
c     2.1     Modified for use with NJOY 97 by allowing upd to write      gaupd.161
c             the name.f and name.lst files directly.  This allows a      gaupd.162
c             simpler "make" process for recompiling and loading NJOY.    gaupd.163
c                                                                         gaupd.164
c     ******************************************************************  gaupd.165
      common /upd1/ nid,nact,ndecks                                       gaupd.166
      common /upd2/ iseq,iseq1                                            gaupd.167
      common /upd3/ iupn,iout,jupn,kold                                   gaupd.168
      common /upd4/ iact(3,9999)                                          gaupd.169
      character*10 id                                                     gaupd.170
      common /upd5/ id(1000)                                              gaupd.171
      common /upd6/ lid(1000)                                             gaupd.172
      common /upd7/ lcds(500),lcde(500),lcdn(500),ncmdk,jc,jcd,           gaupd.173
     x iseqs(500),iptcd(100),ncdid,jdx1,jdx2,noid,nlns                    gaupd.174
      common /upd8/ nupn,ncdu                                             gaupd.175
      character*10 cdnames(500),cdid(100),idid                            gaupd.176
      logical cmdk,dk                                                     gaupd.177
      character*72 iline,lline                                            gaupd.178
      character*10 opr,opn                                                gaupd.179
      character*10 id1,id2                                                gaupd.180
      character*13 label                                                  gaupd.181
      character*6 vers                                                    gaupd.182
      character*10 cnames(100),swords(100),gettok,lnames(100)             gaupd.183
      character*10 cname,fname,suff                                       gaupd.184
      external gettok                                                     gaupd.185
      character*7 sname                                                   gaupd.186
      logical new,list,compl,noid,nlns                                    gaupd.187
      logical cdeck                                                       gaupd.188
      logical on(20),skip(20)                                             gaupd.189
c                                                                         gaupd.190
c     ***initialize                                                       gaupd.191
      iout=6                                                              gaupd.192
c     open(iout,status='unknown',file='tty')                              gaupd.193
      vers='2.1'                                                          gaupd.194
      llen=72                                                             gaupd.195
      write(iout,'('' gaupd: vers: '',a)') vers                           gaupd.196
      ncmdk=0                                                             gaupd.197
      jc=0                                                                gaupd.198
      lc=0                                                                gaupd.199
      cmdk=.false.                                                        gaupd.200
      dk=.false.                                                          gaupd.201
      suff='.f'                                                           gaupd.202
c                                                                         gaupd.203
c     ***read in the src file                                             gaupd.204
      nsrc=1                                                              gaupd.205
      open(nsrc,file='src',status='old')                                  gaupd.206
      ntmp=11                                                             gaupd.207
      open(ntmp,status='scratch')                                         gaupd.208
      ncdid=0                                                             gaupd.209
      nid=0                                                               gaupd.210
      nact=0                                                              gaupd.211
      iseq=0                                                              gaupd.212
      isrc=0                                                              gaupd.213
      jsrc=0                                                              gaupd.214
  110 isrc=isrc+1                                                         gaupd.215
      read(nsrc,'(a)',end=120) iline                                      gaupd.216
      jsrc=jsrc+1                                                         gaupd.217
 112  if(iline(1:8).ne.'*comdeck') write(ntmp,'(a)') iline                gaupd.218
      if (iline(1:5).eq.'*deck'.and.(dk.or.nid.eq.0)) then                gaupd.219
         if (nid.gt.0) then                                               gaupd.220
            iact(3,nact)=iseq                                             gaupd.221
            iseq=0                                                        gaupd.222
         endif                                                            gaupd.223
         if(ncmdk.gt.0.and.cmdk) then                                     gaupd.224
           lcde(ncmdk)=jc                                                 gaupd.225
           cmdk=.false.                                                   gaupd.226
         endif                                                            gaupd.227
         dk=.true.                                                        gaupd.228
         nid=nid+1                                                        gaupd.229
         if (nid.gt.1000)                                                 gaupd.230
     1      call error('too many identifiers (1000 max)')                 gaupd.231
         id(nid)=iline(7:16)                                              gaupd.232
         lid(nid)=isrc                                                    gaupd.233
         nact=nact+1                                                      gaupd.234
         if (nact.gt.9999)                                                gaupd.235
     1      call error('too many active line entries (9999 max)')         gaupd.236
         iact(1,nact)=nid                                                 gaupd.237
         iact(2,nact)=1                                                   gaupd.238
      endif                                                               gaupd.239
      if(iline(1:8).eq.'*comdeck') then                                   gaupd.240
         if(nid.gt.0.and.dk) then                                         gaupd.241
            iact(3,nact)=iseq                                             gaupd.242
            dk=.false.                                                    gaupd.243
            iseq=0                                                        gaupd.244
         endif                                                            gaupd.245
         if(ncmdk.gt.0.and.cmdk) then                                     gaupd.246
            lcde(ncmdk)=jc                                                gaupd.247
         endif                                                            gaupd.248
         jcd=1                                                            gaupd.249
         cmdk=.true.                                                      gaupd.250
         if(ncmdk.eq.0) then                                              gaupd.251
            ncdu=12                                                       gaupd.252
c dwm    changed record length from 84 to 85 in following line            gaupd.253
            open(ncdu,status='unknown',access='direct',recl=85)           gaupd.254
         endif                                                            gaupd.255
         ncmdk=ncmdk+1                                                    gaupd.256
         cdnames(ncmdk)=iline(10:19)                                      gaupd.257
         ncdid=ncdid+1                                                    gaupd.258
         cdid(ncdid)=cdnames(ncmdk)                                       gaupd.259
         iptcd(ncdid)=ncmdk                                               gaupd.260
         if(ncmdk.gt.500) call error('too many comdecks (500 max)')       gaupd.261
         lcds(ncmdk)=jc+1                                                 gaupd.262
         lcdn(ncmdk)=0                                                    gaupd.263
         iseqs(ncmdk)=2                                                   gaupd.264
 115     read(nsrc,'(a)',end=117) iline                                   gaupd.265
         jsrc=jsrc+1                                                      gaupd.266
         if(iline(1:1).eq.'*') go to 112                                  gaupd.267
         jcd=jcd+1                                                        gaupd.268
         jc=jc+1                                                          gaupd.269
         if(noid) then                                                    gaupd.270
            label=' '                                                     gaupd.271
         else                                                             gaupd.272
            call packl(cdnames(ncmdk),jcd,label)                          gaupd.273
         endif                                                            gaupd.274
         write(ncdu,rec=jc) iline,label                                   gaupd.275
         go to 115                                                        gaupd.276
 117     lcde(ncmdk)=jc                                                   gaupd.277
         go to 121                                                        gaupd.278
      endif                                                               gaupd.279
      iseq=iseq+1                                                         gaupd.280
      go to 110                                                           gaupd.281
  120 iact(3,nact)=iseq                                                   gaupd.282
  121 ndecks=nid                                                          gaupd.283
      isrc=isrc-1                                                         gaupd.284
      write(iout,'('' gaupd: src:'',i6,'' cards '',i4,'' decks'')')       gaupd.285
     1   jsrc,ndecks                                                      gaupd.286
c                                                                         gaupd.287
c     ***read the upd input "upn" file,                                   gaupd.288
c     ***copy the lines to a direct access file,                          gaupd.289
c     ***and make a table of active lines                                 gaupd.290
      nupn=2                                                              gaupd.291
      open(nupn,file='upn',status='old')                                  gaupd.292
c dwm                                                                     mar29.12
      call fixinp (nupn)                                                  mar29.13
      ndir=3                                                              gaupd.293
      open(ndir,status='scratch',access='direct',recl=llen)               gaupd.294
      nnames=0                                                            gaupd.295
      nlistn=0                                                            gaupd.296
      nwords=0                                                            gaupd.297
      new=.false.                                                         gaupd.298
      list=.false.                                                        gaupd.299
      noid=.false.                                                        gaupd.300
      iupn=0                                                              gaupd.301
      jupn=0                                                              gaupd.302
      knew=1                                                              gaupd.303
      opr=' '                                                             gaupd.304
      lupn=0                                                              gaupd.305
  140 iupn=iupn+1                                                         gaupd.306
      read(nupn,'(a)',end=150) iline                                      gaupd.307
      jupn=jupn+1                                                         gaupd.308
      jcd=jcd+1                                                           gaupd.309
 145  if(iline(1:8).ne.'*comdeck') write(ndir,rec=iupn) iline             gaupd.310
      go to 160                                                           gaupd.311
  150 iline='*end'                                                        gaupd.312
c                                                                         gaupd.313
c     ***is this an operation?                                            gaupd.314
  160 if (iline(1:1).ne.'*') go to 175                                    gaupd.315
      kold=knew                                                           gaupd.316
      knew=jupn                                                           gaupd.317
      if (iline(1:2).eq.'*/') go to 175                                   gaupd.318
      if(iline(1:5).eq.'*call') go to 175                                 gaupd.319
      j=1                                                                 gaupd.320
      call getopr(j,iline,opn)                                            gaupd.321
      if (opn.eq.'*ident') idid=iline(8:17)                               gaupd.322
      if (opn.eq.'*ident') jcd=1                                          gaupd.323
      if (opn.ne.'*ident'.and.opn.ne.'*b'.and.opn.ne.'*d'                 gaupd.324
     x   .and.opn.ne.'*i'.and.opn.ne.'*end'.and.opn.ne.'*deck'            gaupd.325
     x    .and.opn.ne.'*comdeck') go to 170                               gaupd.326
c                                                                         gaupd.327
c     ***perform the pending operation                                    gaupd.328
      if (opr.eq.'*ident') then                                           gaupd.329
         nid=nid+1                                                        gaupd.330
         if (nid.gt.1000)                                                 gaupd.331
     1      call error('too many identifiers (1000 max)')                 gaupd.332
         id(nid)=lline(8:n)                                               gaupd.333
         lid(nid)=-lupn                                                   gaupd.334
         iseq=iupn-lupn+1                                                 gaupd.335
         iseq1=iseq                                                       gaupd.336
      elseif (opr.eq.'*b') then                                           gaupd.337
         call getadr(i,lline,id1,n1,id2,n2)                               gaupd.338
         call before(id1,n1)                                              gaupd.339
      elseif (opr.eq.'*d') then                                           gaupd.340
         call getadr(i,lline,id1,n1,id2,n2)                               gaupd.341
         call delete(id1,n1,id2,n2)                                       gaupd.342
      elseif (opr.eq.'*i') then                                           gaupd.343
         call getadr(i,lline,id1,n1,id2,n2)                               gaupd.344
         call insert(id1,n1)                                              gaupd.345
      endif                                                               gaupd.346
c                                                                         gaupd.347
c      *** look for comdeck operations                                    gaupd.348
      if(opn.eq.'*b'.or.opn.eq.'*d'.or.opn.eq.'*i') then                  gaupd.349
         i=1                                                              gaupd.350
         call getadr(i,iline,id1,n1,id2,n2)                               gaupd.351
         call getcd(cdnames,cdid,idid,id1,n1,id2,n2)                      gaupd.352
         if(jdx1.ne.0) then                                               gaupd.353
            call fixcd(cdnames,cdid,idid,opn,id1,n1,id2,n2,iline)         gaupd.354
            opr=' '                                                       gaupd.355
            iseq=iseq+2                                                   gaupd.356
            iupn=iupn+1                                                   gaupd.357
            iseq1=iseq                                                    gaupd.358
            lupn=iupn                                                     gaupd.359
            go to 145                                                     gaupd.360
         endif                                                            gaupd.361
      endif                                                               gaupd.362
c                                                                         gaupd.363
c      *** if operation is deck add these cards to the end of the         gaupd.364
c          copied source file and update active table                     gaupd.365
      if(opn.eq.'*deck') then                                             gaupd.366
         isrc=isrc+1                                                      gaupd.367
         ndecks=ndecks+1                                                  gaupd.368
         iseql=0                                                          gaupd.369
         nid=nid+1                                                        gaupd.370
         if(nid.gt.1000) call                                             gaupd.371
     x      error('too many identifiers (1000 max)')                      gaupd.372
         id(nid)=iline(7:16)                                              gaupd.373
         lid(nid)=isrc                                                    gaupd.374
         nact=nact+1                                                      gaupd.375
         iact(1,nact)=nid                                                 gaupd.376
         iact(2,nact)=1                                                   gaupd.377
         write(ntmp,'(a)') iline                                          gaupd.378
 162     read(nupn,'(a)',end=161) iline                                   gaupd.379
         jupn=jupn+1                                                      gaupd.380
         iseql=iseql+1                                                    gaupd.381
         if(iline(1:1).eq.'*') then                                       gaupd.382
            opr=' '                                                       gaupd.383
            iact(3,nact)=iseql                                            gaupd.384
            iseql=0                                                       gaupd.385
            go to 145                                                     gaupd.386
         else                                                             gaupd.387
            write(ntmp,'(a)') iline                                       gaupd.388
            go to 162                                                     gaupd.389
         endif                                                            gaupd.390
 161     opr=' '                                                          gaupd.391
         iact(3,nact)=iseql+1                                             gaupd.392
         iseql=0                                                          gaupd.393
         go to 150                                                        gaupd.394
      endif                                                               gaupd.395
c                                                                         gaupd.396
c      ***if operation is comdeck move cards to direct access             gaupd.397
c         comdeck file                                                    gaupd.398
      if(opn.eq.'*comdeck') then                                          gaupd.399
         nln=1                                                            gaupd.400
         if(ncmdk.eq.0) then                                              gaupd.401
            ncdu=12                                                       gaupd.402
c dwm    changed record length from 84 to 85 in following line            gaupd.403
            open(ncdu,status='unknown',access='direct',recl=85)           gaupd.404
         endif                                                            gaupd.405
         ncmdk=ncmdk+1                                                    gaupd.406
         if(ncmdk.gt.500) call error('too many comdecks (500 max)')       gaupd.407
         cdnames(ncmdk)=iline(10:19)                                      gaupd.408
         ncdid=ncdid+1                                                    gaupd.409
         cdid(ncdid)=cdnames(ncmdk)                                       gaupd.410
         iptcd(ncdid)=ncmdk                                               gaupd.411
         lcds(ncmdk)=jc+1                                                 gaupd.412
         lcdn(ncmdk)=0                                                    gaupd.413
         iseqs(ncmdk)=2                                                   gaupd.414
 166     read(nupn,'(a)',end=169) iline                                   gaupd.415
         jupn=jupn+1                                                      gaupd.416
         if(iline(1:1).eq.'*') go to 168                                  gaupd.417
         nln=nln+1                                                        gaupd.418
         jc=jc+1                                                          gaupd.419
         if(noid) then                                                    gaupd.420
            label=' '                                                     gaupd.421
         else                                                             gaupd.422
            call packl(cdnames(ncmdk),nln,label)                          gaupd.423
         endif                                                            gaupd.424
         write(ncdu,rec=jc) iline,label                                   gaupd.425
         go to 166                                                        gaupd.426
 168     lcde(ncmdk)=jc                                                   gaupd.427
         opr=' '                                                          gaupd.428
         go to 160                                                        gaupd.429
 169     lcde(ncmdk)=jc                                                   gaupd.430
         opr=' '                                                          gaupd.431
         go to 150                                                        gaupd.432
      endif                                                               gaupd.433
c                                                                         gaupd.434
c     ***get the new operation                                            gaupd.435
      i=j                                                                 gaupd.436
      opr=opn                                                             gaupd.437
      n=len(iline)                                                        gaupd.438
      if (opr.eq.'*end') go to 180                                        gaupd.439
      lline=iline                                                         gaupd.440
      lupn=iupn                                                           gaupd.441
      iseq=iseq+1                                                         gaupd.442
      iseq1=iseq                                                          gaupd.443
      go to 140                                                           gaupd.444
c                                                                         gaupd.445
c     ***is this a upd command?                                           gaupd.446
  170 iseq=iseq+1                                                         gaupd.447
      nn=len(iline)                                                       gaupd.448
      if (opn.eq.'*npl') then                                             gaupd.449
         new=.true.                                                       gaupd.450
         opr=opn                                                          gaupd.451
         go to 140                                                        gaupd.452
      elseif (opn.eq.'*lst') then                                         gaupd.453
         list=.true.                                                      gaupd.454
         idx=6                                                            gaupd.455
 172     lnames(nlistn+1)=gettok(iline,idx,nn)                            gaupd.456
         if(lnames(nlistn+1).ne.' ') then                                 gaupd.457
           nlistn=nlistn+1                                                gaupd.458
           if(idx.lt.nn) go to 172                                        gaupd.459
         endif                                                            gaupd.460
         opr=opn                                                          gaupd.461
         go to 140                                                        gaupd.462
      elseif (opn.eq.'*cpl') then                                         gaupd.463
         compl=.true.                                                     gaupd.464
         idx=6                                                            gaupd.465
 173     cnames(nnames+1)=gettok(iline,idx,nn)                            gaupd.466
         if(cnames(nnames+1).ne.' ') then                                 gaupd.467
           nnames=nnames+1                                                gaupd.468
           if(idx.lt.nn) go to 173                                        gaupd.469
         endif                                                            gaupd.470
         opr=opn                                                          gaupd.471
         go to 140                                                        gaupd.472
      elseif (opn.eq.'*noid') then                                        gaupd.473
         noid=.true.                                                      gaupd.474
         opr=opn                                                          gaupd.475
         go to 140                                                        gaupd.476
      elseif (opn.eq.'*set') then                                         gaupd.477
         idx=6                                                            gaupd.478
 174     swords(nwords+1)=gettok(iline,idx,nn)                            gaupd.479
         if(swords(nwords+1).ne.' ') then                                 gaupd.480
           nwords=nwords+1                                                gaupd.481
           if(idx.lt.nn) go to 174                                        gaupd.482
         endif                                                            gaupd.483
         opr=opn                                                          gaupd.484
         go to 140                                                        gaupd.485
      else                                                                gaupd.486
         go to 140                                                        gaupd.487
      endif                                                               gaupd.488
c                                                                         gaupd.489
c     ***data line                                                        gaupd.490
  175 iseq=iseq+1                                                         gaupd.491
      go to 140                                                           gaupd.492
c                                                                         gaupd.493
c     ***finished up the "upn" file                                       gaupd.494
 180  write(iout,'('' gaupd: upn:'',i6,'' cards '',i4,'' idents'')')      gaupd.495
     1   jupn,nid-ndecks                                                  gaupd.496
      if(.not.compl) go to 300                                            gaupd.497
c                                                                         gaupd.498
c     ***write the "cpl" file or the "name.f" files                       gaupd.499
      ncpl=4                                                              gaupd.500
      icpl=0                                                              gaupd.501
      rewind ntmp                                                         gaupd.502
      isrc=0                                                              gaupd.503
      if (nnames.eq.0) open(ncpl,file='cpl',status='unknown')             gaupd.504
      cname='none'                                                        gaupd.505
      cdeck=.true.                                                        gaupd.506
      do 181 i=1,20                                                       gaupd.507
 181  on(i)=.true.                                                        gaupd.508
      do 290 i=1,nact                                                     gaupd.509
c                                                                         gaupd.510
c     ***get the parameters for this table entry                          gaupd.511
      k1=iact(1,i)                                                        gaupd.512
      id1=id(k1)                                                          gaupd.513
      i1=iact(2,i)                                                        gaupd.514
      i2=iact(3,i)                                                        gaupd.515
      do 190 j=1,nid                                                      gaupd.516
      k=j                                                                 gaupd.517
      if (id1.eq.id(j)) go to 200                                         gaupd.518
  190 continue                                                            gaupd.519
  200 l=iabs(lid(k))                                                      gaupd.520
      dk=.false.                                                          gaupd.521
      if(lid(k).gt.0) dk=.true.                                           gaupd.522
      if (i1.gt.1) go to 205                                              gaupd.523
      if (nnames.eq.0) go to 205                                          gaupd.524
      cdeck=.false.                                                       gaupd.525
      do 204 j=1,nnames                                                   gaupd.526
      if (cnames(j).eq.id1) cdeck=.true.                                  gaupd.527
  204 continue                                                            gaupd.528
      if (cnames(1).eq.'all') cdeck=.true.                                gaupd.529
      if (.not.cdeck) go to 205                                           gaupd.530
      if (cname.eq.id1) go to 205                                         gaupd.531
      if (cname.ne.'none') close(ncpl)                                    gaupd.532
      cname=id1                                                           gaupd.533
      jj=0                                                                gaupd.534
      do 206 j=1,10                                                       gaupd.535
      if (cname(j:j).ne.' ') jj=j                                         gaupd.536
  206 continue                                                            gaupd.537
      fname=cname(1:jj)//suff                                             gaupd.538
      open(ncpl,file=fname,status='unknown')                              gaupd.539
  205 if(.not.dk) go to 240                                               gaupd.540
c                                                                         gaupd.541
c     ***take lines from "src" decks                                      gaupd.542
      nskip=l+i1-isrc-2                                                   gaupd.543
      if (nskip.le.0) go to 220                                           gaupd.544
      do 210 ii=1,nskip                                                   gaupd.545
      isrc=isrc+1                                                         gaupd.546
      read (ntmp,'(a)') iline                                             gaupd.547
  210 continue                                                            gaupd.548
  220 nkeep=i2-i1+1                                                       gaupd.549
      do 230 ii=1,nkeep                                                   gaupd.550
      isrc=isrc+1                                                         gaupd.551
      read (ntmp,'(a)') iline                                             gaupd.552
c                                                                         gaupd.553
c     ***check whether this line is to be written                         gaupd.554
      if (.not.cdeck) go to 230                                           gaupd.555
      if (iline(1:5).eq.'*deck') go to 230                                gaupd.556
      if (iline(1:3).eq.'*if') then                                       gaupd.557
         lc=lc+1                                                          gaupd.558
         skip(lc)=.false.                                                 gaupd.559
         on(lc)=.false.                                                   gaupd.560
         if (nwords.eq.0) go to 230                                       gaupd.561
         do 225 j=1,nwords                                                gaupd.562
         if (swords(j).eq.iline(5:n)) on(lc)=.true.                       gaupd.563
  225    continue                                                         gaupd.564
         if (on(lc)) skip(lc)=.true.                                      gaupd.565
         go to 230                                                        gaupd.566
      elseif (iline(1:7).eq.'*elseif') then                               gaupd.567
         if(lc.eq.0) call error('illegal use of *if statements')          gaupd.568
         if (skip(lc)) then                                               gaupd.569
            on(lc)=.false.                                                gaupd.570
            go to 230                                                     gaupd.571
         endif                                                            gaupd.572
         on(lc)=.false.                                                   gaupd.573
         if (nwords.eq.0) go to 230                                       gaupd.574
         do 226 j=1,nwords                                                gaupd.575
         if (swords(j).eq.iline(9:n)) on(lc)=.true.                       gaupd.576
  226    continue                                                         gaupd.577
         if (on(lc)) skip(lc)=.true.                                      gaupd.578
         go to 230                                                        gaupd.579
      elseif (iline(1:5).eq.'*else') then                                 gaupd.580
         if(lc.eq.0) call error('illegal use of *if statements')          gaupd.581
         on(lc)=.not.skip(lc)                                             gaupd.582
         go to 230                                                        gaupd.583
      elseif (iline(1:6).eq.'*endif') then                                gaupd.584
         lc=lc-1                                                          gaupd.585
         if(lc.lt.0) call error('illegal use of *if statements')          gaupd.586
         go to 230                                                        gaupd.587
      endif                                                               gaupd.588
      if(lc.gt.0) then                                                    gaupd.589
         do 221 ll=1,lc                                                   gaupd.590
         if(.not.on(ll)) go to 230                                        gaupd.591
 221     continue                                                         gaupd.592
      endif                                                               gaupd.593
c                                                                         gaupd.594
c     ***expand *call with appropriate comdeck                            gaupd.595
      if(iline(1:5).eq.'*call') then                                      gaupd.596
        do 228 i1=1,ncdid                                                 gaupd.597
        if(cdid(i1).eq.iline(7:16)) then                                  gaupd.598
           j=iptcd(i1)                                                    gaupd.599
           k=lcds(j)                                                      gaupd.600
  227      read(ncdu,rec=k) iline,label                                   gaupd.601
           icpl=icpl+1                                                    gaupd.602
           if (noid) then                                                 gaupd.603
              write(ncpl,'(a)') iline                                     gaupd.604
           else                                                           gaupd.605
              write(ncpl,'(a72,a13)') iline,label                         gaupd.606
           endif                                                          gaupd.607
           k=k+1                                                          gaupd.608
           if(k.le.lcde(j)) go to 227                                     gaupd.609
           m=lcdn(j)                                                      gaupd.610
           if(m.gt.0) then                                                gaupd.611
              k=lcds(m)                                                   gaupd.612
              j=m                                                         gaupd.613
              go to 227                                                   gaupd.614
           endif                                                          gaupd.615
           go to 229                                                      gaupd.616
        endif                                                             gaupd.617
 228    continue                                                          gaupd.618
        call error('cant find comdeck')                                   gaupd.619
 229    continue                                                          gaupd.620
        go to 230                                                         gaupd.621
      endif                                                               gaupd.622
c                                                                         gaupd.623
c     ***write the line with or without label                             gaupd.624
      if (noid) then                                                      gaupd.625
         write(ncpl,'(a)') iline                                          gaupd.626
      else                                                                gaupd.627
         call packl(id1,isrc-l+1,label)                                   gaupd.628
         write (ncpl,'(a72,a13)') iline,label                             gaupd.629
      endif                                                               gaupd.630
      icpl=icpl+1                                                         gaupd.631
  230 continue                                                            gaupd.632
      go to 290                                                           gaupd.633
                                                                          gaupd.634
c     ***take lines from "upn" input                                      gaupd.635
  240 nkeep=i2-i1+1                                                       gaupd.636
      do 250 ii=1,nkeep                                                   gaupd.637
      read (ndir,rec=l+i1+ii-2) iline                                     gaupd.638
c                                                                         gaupd.639
c     ***check whether this line is to be written                         gaupd.640
      if (.not.cdeck) go to 250                                           gaupd.641
c                                                                         gaupd.642
c     ***expand *call with appropriate comdeck                            gaupd.643
      if(iline(1:5).eq.'*call') then                                      gaupd.644
        do 243 i1=1,ncdid                                                 gaupd.645
        if(cdid(i1).eq.iline(7:16)) then                                  gaupd.646
           j=iptcd(i1)                                                    gaupd.647
           k=lcds(j)                                                      gaupd.648
  241      read(ncdu,rec=k) iline,label                                   gaupd.649
           icpl=icpl+1                                                    gaupd.650
           if (noid) then                                                 gaupd.651
              write(ncpl,'(a)') iline                                     gaupd.652
           else                                                           gaupd.653
              write(ncpl,'(a72,a13)') iline,label                         gaupd.654
           endif                                                          gaupd.655
           k=k+1                                                          gaupd.656
           if(k.le.lcde(j)) go to 241                                     gaupd.657
           m=lcdn(j)                                                      gaupd.658
           if(m.gt.0) then                                                gaupd.659
              k=lcds(m)                                                   gaupd.660
              j=m                                                         gaupd.661
              go to 241                                                   gaupd.662
           endif                                                          gaupd.663
           go to 244                                                      gaupd.664
        endif                                                             gaupd.665
 243    continue                                                          gaupd.666
        call error('cant find comdeck')                                   gaupd.667
 244    continue                                                          gaupd.668
        go to 250                                                         gaupd.669
      endif                                                               gaupd.670
      if (iline(1:3).eq.'*if') then                                       gaupd.671
         lc=lc+1                                                          gaupd.672
         skip(lc)=.false.                                                 gaupd.673
         on(lc)=.false.                                                   gaupd.674
         if (nwords.eq.0) go to 250                                       gaupd.675
         do 245 j=1,nwords                                                gaupd.676
         if (swords(j).eq.iline(5:n)) on(lc)=.true.                       gaupd.677
  245    continue                                                         gaupd.678
         if (on(lc)) skip(lc)=.true.                                      gaupd.679
         go to 250                                                        gaupd.680
      elseif (iline(1:7).eq.'*elseif') then                               gaupd.681
         if(lc.eq.0) call error('illegal use of *if statements')          gaupd.682
         if (skip(lc)) then                                               gaupd.683
            on(lc)=.false.                                                gaupd.684
            go to 250                                                     gaupd.685
         endif                                                            gaupd.686
         on(lc)=.false.                                                   gaupd.687
         if (nwords.eq.0) go to 250                                       gaupd.688
         do 246 j=1,nwords                                                gaupd.689
         if (swords(j).eq.iline(9:n)) on(lc)=.true.                       gaupd.690
  246    continue                                                         gaupd.691
         if (on(lc)) skip(lc)=.true.                                      gaupd.692
         go to 250                                                        gaupd.693
      elseif (iline(1:5).eq.'*else') then                                 gaupd.694
         if(lc.eq.0) call error('illegal use of *if statements')          gaupd.695
         on(lc)=.not.skip(lc)                                             gaupd.696
         go to 250                                                        gaupd.697
      elseif (iline(1:6).eq.'*endif') then                                gaupd.698
         lc=lc-1                                                          gaupd.699
         if(lc.lt.0) call error('illegal use of *if statements')          gaupd.700
         go to 250                                                        gaupd.701
      endif                                                               gaupd.702
      if(lc.gt.0) then                                                    gaupd.703
         do 247 ll=1,lc                                                   gaupd.704
         if(.not.on(ll)) go to 250                                        gaupd.705
 247     continue                                                         gaupd.706
      endif                                                               gaupd.707
      if (iline(1:2).eq.'*/') go to 250                                   gaupd.708
c                                                                         gaupd.709
c     ***write the line with or without label                             gaupd.710
      if (noid) then                                                      gaupd.711
         write(ncpl,'(a)') iline                                          gaupd.712
      else                                                                gaupd.713
         call packl(id1,i1+ii-1,label)                                    gaupd.714
         write (ncpl,'(a72,a13)') iline,label                             gaupd.715
      endif                                                               gaupd.716
      icpl=icpl+1                                                         gaupd.717
  250 continue                                                            gaupd.718
c                                                                         gaupd.719
c     ***continue loop over entries in table of active lines              gaupd.720
  290 continue                                                            gaupd.721
      write(iout,'('' gaupd: cpl:'',i6,'' lines written'')') icpl         gaupd.722
      if(lc.ne.0) call error('illegal use of *if statement')              gaupd.723
      close (ncpl)                                                        gaupd.724
c                                                                         gaupd.725
c     ***write the "npl" file                                             gaupd.726
 300  if(.not.new) go to 400                                              gaupd.727
      nnpl=4                                                              gaupd.728
      inpl=0                                                              gaupd.729
      rewind ntmp                                                         gaupd.730
      isrc=0                                                              gaupd.731
      open(nnpl,file='npl',status='unknown')                              gaupd.732
      do 390 i=1,nact                                                     gaupd.733
c                                                                         gaupd.734
c     ***get the parameters for this table entry                          gaupd.735
      k1=iact(1,i)                                                        gaupd.736
      id1=id(k1)                                                          gaupd.737
      i1=iact(2,i)                                                        gaupd.738
      i2=iact(3,i)                                                        gaupd.739
      do 310 j=1,nid                                                      gaupd.740
      k=j                                                                 gaupd.741
      if (id1.eq.id(j)) go to 320                                         gaupd.742
  310 continue                                                            gaupd.743
  320 l=iabs(lid(k))                                                      gaupd.744
      dk=.false.                                                          gaupd.745
      if(lid(k).gt.0) dk=.true.                                           gaupd.746
      if (.not.dk) go to 360                                              gaupd.747
c                                                                         gaupd.748
c     ***take lines from "src" decks                                      gaupd.749
      nskip=l+i1-isrc-2                                                   gaupd.750
      if (nskip.le.0) go to 340                                           gaupd.751
      do 330 ii=1,nskip                                                   gaupd.752
      isrc=isrc+1                                                         gaupd.753
      read (ntmp,'(a)') iline                                             gaupd.754
  330 continue                                                            gaupd.755
  340 nkeep=i2-i1+1                                                       gaupd.756
      do 350 ii=1,nkeep                                                   gaupd.757
      isrc=isrc+1                                                         gaupd.758
      read (ntmp,'(a)') iline                                             gaupd.759
      if (iline(1:2).eq.'*/') go to 350                                   gaupd.760
      inpl=inpl+1                                                         gaupd.761
      write (nnpl,'(a72)') iline                                          gaupd.762
  350 continue                                                            gaupd.763
      go to 390                                                           gaupd.764
                                                                          gaupd.765
c     ***take lines from "upn" input                                      gaupd.766
  360 nkeep=i2-i1+1                                                       gaupd.767
      do 370 ii=1,nkeep                                                   gaupd.768
      read (ndir,rec=l+i1+ii-2) iline                                     gaupd.769
      if (iline(1:2).eq.'*/') go to 370                                   gaupd.770
      inpl=inpl+1                                                         gaupd.771
      write (nnpl,'(a72)') iline                                          gaupd.772
  370 continue                                                            gaupd.773
c                                                                         gaupd.774
c     ***continue loop over entries in table of active lines              gaupd.775
  390 continue                                                            gaupd.776
c                                                                         gaupd.777
c     ***list comdecks                                                    gaupd.778
      if(ncdid.ne.0) then                                                 gaupd.779
         do 399 i=1,ncdid                                                 gaupd.780
         j=iptcd(i)                                                       gaupd.781
         write(nnpl,391) cdnames(j)                                       gaupd.782
         inpl=inpl+1                                                      gaupd.783
 391     format('*comdeck ',a10)                                          gaupd.784
         k=lcds(j)                                                        gaupd.785
 392     read(ncdu,rec=k) iline                                           gaupd.786
         write(nnpl,'(a)') iline                                          gaupd.787
         inpl=inpl+1                                                      gaupd.788
         k=k+1                                                            gaupd.789
         if(k.le.lcde(j)) go to 392                                       gaupd.790
         m=lcdn(j)                                                        gaupd.791
         j=m                                                              gaupd.792
         if(m.eq.0) go to 399                                             gaupd.793
         k=lcds(m)                                                        gaupd.794
         go to 392                                                        gaupd.795
 399     continue                                                         gaupd.796
      endif                                                               gaupd.797
      write(iout,'('' gaupd: npl:'',i6,'' lines written'')') inpl         gaupd.798
      close (nnpl)                                                        gaupd.799
c                                                                         gaupd.800
c     ***write the "lst" file                                             gaupd.801
 400  if(.not.list) go to 500                                             gaupd.802
      nlst=4                                                              gaupd.803
      ilst=0                                                              gaupd.804
      rewind ntmp                                                         gaupd.805
      isrc=0                                                              gaupd.806
      if (nlistn.eq.0) open(nlst,file='lst',status='unknown')             gaupd.807
      cname='none'                                                        gaupd.808
      do 490 i=1,nact                                                     gaupd.809
c                                                                         gaupd.810
c     ***get the parameters for this table entry                          gaupd.811
      k1=iact(1,i)                                                        gaupd.812
      id1=id(k1)                                                          gaupd.813
      i1=iact(2,i)                                                        gaupd.814
      i2=iact(3,i)                                                        gaupd.815
      do 410 j=1,nid                                                      gaupd.816
      k=j                                                                 gaupd.817
      if (id1.eq.id(j)) go to 420                                         gaupd.818
  410 continue                                                            gaupd.819
  420 l=iabs(lid(k))                                                      gaupd.820
      dk=.false.                                                          gaupd.821
      if(lid(k).gt.0) dk=.true.                                           gaupd.822
      if (i1.gt.1) go to 425                                              gaupd.823
      cdeck=.true.                                                        gaupd.824
      if(nlistn.eq.0) go to 425                                           gaupd.825
      cdeck=.false.                                                       gaupd.826
      do 424 j=1,nlistn                                                   gaupd.827
      if (lnames(j).eq.id1) cdeck=.true.                                  gaupd.828
  424 continue                                                            gaupd.829
      if (lnames(1).eq.'all') cdeck=.true.                                gaupd.830
      if (.not.cdeck) go to 425                                           gaupd.831
      if (cname.eq.id1) go to 425                                         gaupd.832
      if (cname.ne.'none') close(nlst)                                    gaupd.833
      cname=id1                                                           gaupd.834
      jj=0                                                                gaupd.835
      do 423 j=1,10                                                       gaupd.836
      if (cname(j:j).ne.' ') jj=j                                         gaupd.837
  423 continue                                                            gaupd.838
      fname=cname(1:jj)//'.lst'                                           gaupd.839
      open(nlst,file=fname,status='unknown')                              gaupd.840
  425 if(.not.dk) go to 460                                               gaupd.841
c                                                                         gaupd.842
c     ***take lines from "src" decks                                      gaupd.843
      nskip=l+i1-isrc-2                                                   gaupd.844
      if (nskip.le.0) go to 440                                           gaupd.845
      do 430 ii=1,nskip                                                   gaupd.846
      isrc=isrc+1                                                         gaupd.847
      read (ntmp,'(a)') iline                                             gaupd.848
  430 continue                                                            gaupd.849
  440 nkeep=i2-i1+1                                                       gaupd.850
      do 450 ii=1,nkeep                                                   gaupd.851
      isrc=isrc+1                                                         gaupd.852
      read (ntmp,'(a)') iline                                             gaupd.853
      j=0                                                                 gaupd.854
      if(iline(1:1).ne.'c') then                                          gaupd.855
         jj=7                                                             gaupd.856
         call skipb(iline,jj)                                             gaupd.857
         if (iline(jj:jj+6).eq.'program') then                            gaupd.858
            j=jj+8                                                        gaupd.859
         elseif (iline(jj:jj+9).eq.'subroutine') then                     gaupd.860
            j=jj+11                                                       gaupd.861
         elseif (iline(jj:jj+7).eq.'function') then                       gaupd.862
            j=jj+9                                                        gaupd.863
         else                                                             gaupd.864
            do 441 jk=jj,nn                                               gaupd.865
            if(iline(jk:jk).eq.' ') go to 442                             gaupd.866
  441       continue                                                      gaupd.867
            go to 443                                                     gaupd.868
  442       call skipb(iline,jk)                                          gaupd.869
            if (iline(jk:jk+6).eq.'program') j=jk+8                       gaupd.870
            if (iline(jk:jk+9).eq.'subroutine') j=jk+11                   gaupd.871
            if (iline(jk:jk+7).eq.'function') j=jk+9                      gaupd.872
         endif                                                            gaupd.873
      endif                                                               gaupd.874
  443 if (j.eq.0) go to 447                                               gaupd.875
      call skipb(iline,j)                                                 gaupd.876
      nn=len(iline)                                                       gaupd.877
      do 445 jj=j,nn                                                      gaupd.878
      k=jj                                                                gaupd.879
      if (iline(jj:jj).eq.'(') go to 446                                  gaupd.880
  445 continue                                                            gaupd.881
  446 k=k-1                                                               gaupd.882
      sname=iline(j:k)                                                    gaupd.883
  447 if (.not.cdeck) go to 450                                           gaupd.884
      if (iline(1:5).eq.'*deck') go to 450                                gaupd.885
      if (iline(1:2).eq.'*/') go to 450                                   gaupd.886
      call packl(id1,isrc-l+1,label)                                      gaupd.887
      ilst=ilst+1                                                         gaupd.888
      write (nlst,'(a13,'' --- '',a72,'' '',a7)') label,iline,sname       gaupd.889
  450 continue                                                            gaupd.890
      go to 490                                                           gaupd.891
                                                                          gaupd.892
c     ***take lines from "upn" input                                      gaupd.893
  460 nkeep=i2-i1+1                                                       gaupd.894
      do 470 ii=1,nkeep                                                   gaupd.895
      read (ndir,rec=l+i1+ii-2) iline                                     gaupd.896
      j=0                                                                 gaupd.897
      if(iline(1:1).ne.'c') then                                          gaupd.898
         jj=7                                                             gaupd.899
         call skipb(iline,jj)                                             gaupd.900
         if (iline(jj:jj+6).eq.'program') then                            gaupd.901
            j=jj+8                                                        gaupd.902
         elseif (iline(jj:jj+9).eq.'subroutine') then                     gaupd.903
            j=jj+11                                                       gaupd.904
         elseif (iline(jj:jj+7).eq.'function') then                       gaupd.905
            j=jj+9                                                        gaupd.906
         else                                                             gaupd.907
            do 461 jk=jj,nn                                               gaupd.908
            if(iline(jk:jk).eq.' ') go to 462                             gaupd.909
  461       continue                                                      gaupd.910
            go to 463                                                     gaupd.911
  462       call skipb(iline,jk)                                          gaupd.912
            if (iline(jk:jk+6).eq.'program') j=jk+8                       gaupd.913
            if (iline(jk:jk+9).eq.'subroutine') j=jk+11                   gaupd.914
            if (iline(jk:jk+7).eq.'function') j=jk+9                      gaupd.915
         endif                                                            gaupd.916
      endif                                                               gaupd.917
  463 if (j.eq.0) go to 467                                               gaupd.918
      call skipb(iline,j)                                                 gaupd.919
      do 465 jj=j,nn                                                      gaupd.920
      k=jj                                                                gaupd.921
      if (iline(jj:jj).eq.'(') go to 466                                  gaupd.922
  465 continue                                                            gaupd.923
  466 k=k-1                                                               gaupd.924
      sname=iline(j:k)                                                    gaupd.925
  467 if (.not.cdeck) go to 470                                           gaupd.926
      if (iline(1:2).eq.'*/') go to 470                                   gaupd.927
      call packl(id1,i1+ii-1,label)                                       gaupd.928
      ilst=ilst+1                                                         gaupd.929
      write (nlst,'(a13,'' --- '',a72,'' '',a7)') label,iline,sname       gaupd.930
  470 continue                                                            gaupd.931
c                                                                         gaupd.932
c     ***continue loop over entries in table of active lines              gaupd.933
  490 continue                                                            gaupd.934
c                                                                         gaupd.935
c     ***list comdecks                                                    gaupd.936
      if(ncdid.ne.0) then                                                 gaupd.937
         do 479 i=1,ncdid                                                 gaupd.938
         cdeck=.true.                                                     gaupd.939
         if(nlistn.ne.0) then                                             gaupd.940
            cdeck=.false.                                                 gaupd.941
            do 471 k=1,nlistn                                             gaupd.942
            if(lnames(k).eq.cdid(i)) cdeck=.true.                         gaupd.943
 471        continue                                                      gaupd.944
         endif                                                            gaupd.945
         if(.not.cdeck) go to 479                                         gaupd.946
         j=iptcd(i)                                                       gaupd.947
         k=lcds(j)                                                        gaupd.948
 472     read(ncdu,rec=k) iline,label                                     gaupd.949
      write (nlst,'(a13,'' --- '',a72,'' '',a7)') label,iline,sname       gaupd.950
         ilst=ilst+1                                                      gaupd.951
         k=k+1                                                            gaupd.952
         if(k.le.lcde(j)) go to 472                                       gaupd.953
         m=lcdn(j)                                                        gaupd.954
         j=m                                                              gaupd.955
         if(m.eq.0) go to 479                                             gaupd.956
         k=lcds(m)                                                        gaupd.957
         go to 472                                                        gaupd.958
 479     continue                                                         gaupd.959
      endif                                                               gaupd.960
      write(iout,'('' gaupd: lst:'',i6,'' lines written'')') ilst         gaupd.961
      close (nlst)                                                        gaupd.962
c                                                                         gaupd.963
  500 write(iout,'('' gaupd: complete'')')                                gaupd.964
      end                                                                 gaupd.965
c                                                                         gaupd.966
      subroutine getopr(i,iline,opr)                                      gaupd.967
c     ******************************************************************  gaupd.968
c     parse the upd command line for the operation                        gaupd.969
c     ******************************************************************  gaupd.970
      character*(*) iline,opr                                             gaupd.971
c                                                                         gaupd.972
      n=len(iline)                                                        gaupd.973
  110 if (i.gt.n) go to 120                                               gaupd.974
      if (iline(i:i).eq.' ') go to 120                                    gaupd.975
      i=i+1                                                               gaupd.976
      go to 110                                                           gaupd.977
  120 opr=iline(1:i-1)                                                    gaupd.978
      return                                                              gaupd.979
      end                                                                 gaupd.980
c                                                                         gaupd.981
      subroutine getadr(i,iline,id1,n1,id2,n2)                            gaupd.982
c     ******************************************************************  gaupd.983
c     parse the upd command line for addresses                            gaupd.984
c     ******************************************************************  gaupd.985
      common /upd1/ nid,nact,ndecks                                       gaupd.986
      character*(*) iline,id1,id2                                         gaupd.987
      integer n1,n2                                                       gaupd.988
c                                                                         gaupd.989
      if(nid-ndecks.eq.0) call error('ident directive missing')           gaupd.990
      n=len(iline)                                                        gaupd.991
      k=0                                                                 gaupd.992
      do 100 j=1,n                                                        gaupd.993
      if (iline(j:j).ne.' ') k=j                                          gaupd.994
  100 continue                                                            gaupd.995
      n=k                                                                 gaupd.996
      j=i                                                                 gaupd.997
      if (j.gt.n) go to 180                                               gaupd.998
  110 if (iline(j:j).eq.'.') go to 120                                    gaupd.999
      if (iline(j:j).eq.' ') i=j+1                                        gaupd.1000
      j=j+1                                                               gaupd.1001
      go to 110                                                           gaupd.1002
  120 id1=iline(i:j-1)                                                    gaupd.1003
      j=j+1                                                               gaupd.1004
      i=j                                                                 gaupd.1005
      n1=0                                                                gaupd.1006
  130 if (j.gt.n) go to 190                                               gaupd.1007
      m=ichar(iline(j:j))-ichar('0')                                      gaupd.1008
      if (m.lt.0.or.m.gt.9) go to 140                                     gaupd.1009
      n1=10*n1+m                                                          gaupd.1010
      j=j+1                                                               gaupd.1011
      go to 130                                                           gaupd.1012
  140 j=j+1                                                               gaupd.1013
      i=j                                                                 gaupd.1014
      m=ichar(iline(j:j))-ichar('0')                                      gaupd.1015
      if (m.lt.0.or.m.gt.9) go to 150                                     gaupd.1016
      id2=id1                                                             gaupd.1017
      n2=0                                                                gaupd.1018
      go to 170                                                           gaupd.1019
  150 if (iline(j:j).eq.'.') go to 160                                    gaupd.1020
      if (iline(j:j).eq.' ') i=i+1                                        gaupd.1021
      j=j+1                                                               gaupd.1022
      go to 150                                                           gaupd.1023
  160 id2=iline(i:j-1)                                                    gaupd.1024
      j=j+1                                                               gaupd.1025
      i=j                                                                 gaupd.1026
      n2=0                                                                gaupd.1027
  170 m=ichar(iline(j:j))-ichar('0')                                      gaupd.1028
      if (m.lt.0.or.m.gt.9) go to 200                                     gaupd.1029
      n2=10*n2+m                                                          gaupd.1030
      j=j+1                                                               gaupd.1031
      go to 170                                                           gaupd.1032
  180 id1=' '                                                             gaupd.1033
      n1=0                                                                gaupd.1034
  190 id2=id1                                                             gaupd.1035
      n2=n1                                                               gaupd.1036
  200 return                                                              gaupd.1037
      end                                                                 gaupd.1038
c                                                                         gaupd.1039
      subroutine before(id1,n1)                                           gaupd.1040
c     ******************************************************************  gaupd.1041
c     insert lines before the specified line                              gaupd.1042
c     ******************************************************************  gaupd.1043
      character*(*) id1                                                   gaupd.1044
      integer n1                                                          gaupd.1045
      common /upd1/ nid,nact,ndecks                                       gaupd.1046
      common /upd2/ iseq,iseq1                                            gaupd.1047
      common /upd4/ iact(3,9999)                                          gaupd.1048
      character*10 id                                                     gaupd.1049
      common /upd5/ id(1000)                                              gaupd.1050
      common /upd6/ lid(1000)                                             gaupd.1051
c                                                                         gaupd.1052
c     ***check the insert id string                                       gaupd.1053
      i1=0                                                                gaupd.1054
      do 110 i=1,nid                                                      gaupd.1055
      if (id1.eq.id(i)) i1=i                                              gaupd.1056
  110 continue                                                            gaupd.1057
      if (i1.eq.0) call error('unknown identifier for before')            gaupd.1058
c                                                                         gaupd.1059
c     ***check the insert line number                                     gaupd.1060
      k1=1                                                                gaupd.1061
  120 if (i1.eq.iact(1,k1)                                                gaupd.1062
     1  .and.n1.ge.iact(2,k1).and.n1.le.iact(3,k1)) go to 130             gaupd.1063
      k1=k1+1                                                             gaupd.1064
      if (k1.le.nact) go to 120                                           gaupd.1065
      call error('line is not active for before')                         gaupd.1066
c                                                                         gaupd.1067
c     ***special case for before the first line in a block                gaupd.1068
  130 if (n1.gt.iact(2,k1)) go to 160                                     gaupd.1069
      n=nact-k1+1                                                         gaupd.1070
      do 150 j=1,n                                                        gaupd.1071
      k=nact-j+1                                                          gaupd.1072
      do 140 l=1,3                                                        gaupd.1073
      iact(l,k+1)=iact(l,k)                                               gaupd.1074
  140 continue                                                            gaupd.1075
  150 continue                                                            gaupd.1076
      nact=nact+1                                                         gaupd.1077
      if (nact.gt.9999)                                                   gaupd.1078
     1   call error('too many active line entries (9999 max)')            gaupd.1079
      iact(1,k1)=nid                                                      gaupd.1080
      iact(2,k1)=iseq1                                                    gaupd.1081
      iact(3,k1)=iseq-1                                                   gaupd.1082
      go to 190                                                           gaupd.1083
c                                                                         gaupd.1084
c     ***open up space in the active lines table                          gaupd.1085
c     ***and fix up the active line data                                  gaupd.1086
  160 n=nact-k1                                                           gaupd.1087
      do 180 j=1,n                                                        gaupd.1088
      k=nact-j+1                                                          gaupd.1089
      do 170 l=1,3                                                        gaupd.1090
      iact(l,k+2)=iact(l,k)                                               gaupd.1091
  170 continue                                                            gaupd.1092
  180 continue                                                            gaupd.1093
      nact=nact+2                                                         gaupd.1094
      if (nact.gt.9999)                                                   gaupd.1095
     1   call error('too many active line entries (9999 max)')            gaupd.1096
      iact(1,k1+2)=iact(1,k1)                                             gaupd.1097
      iact(2,k1+2)=n1                                                     gaupd.1098
      iact(3,k1+2)=iact(3,k1)                                             gaupd.1099
      iact(1,k1+1)=nid                                                    gaupd.1100
      iact(2,k1+1)=iseq1                                                  gaupd.1101
      iact(3,k1+1)=iseq-1                                                 gaupd.1102
      iact(3,k1)=n1-1                                                     gaupd.1103
  190 continue                                                            gaupd.1104
      return                                                              gaupd.1105
      end                                                                 gaupd.1106
c                                                                         gaupd.1107
      subroutine delete(id1,n1,id2,n2)                                    gaupd.1108
c     ******************************************************************  gaupd.1109
c     delete lines, and insert following text (if any)                    gaupd.1110
c     ******************************************************************  gaupd.1111
      character*(*) id1,id2                                               gaupd.1112
      integer n1,n2                                                       gaupd.1113
      common /upd1/ nid,nact,ndecks                                       gaupd.1114
      common /upd2/ iseq,iseq1                                            gaupd.1115
      common /upd4/ iact(3,9999)                                          gaupd.1116
      character*10 id                                                     gaupd.1117
      common /upd5/ id(1000)                                              gaupd.1118
      common /upd6/ lid(1000)                                             gaupd.1119
      character*10 id3                                                    gaupd.1120
      integer n3                                                          gaupd.1121
      logical after                                                       gaupd.1122
c                                                                         gaupd.1123
c     ***check the two id strings                                         gaupd.1124
      i1=0                                                                gaupd.1125
      i2=0                                                                gaupd.1126
      do 110 i=1,nid                                                      gaupd.1127
      if (id1.eq.id(i)) i1=i                                              gaupd.1128
      if (id2.eq.id(i)) i2=i                                              gaupd.1129
  110 continue                                                            gaupd.1130
      if (i1.eq.0) call error('unknown identifier for delete')            gaupd.1131
      if (i2.eq.0) call error('unknown identifier for delete')            gaupd.1132
c                                                                         gaupd.1133
c     ***check the two line numbers                                       gaupd.1134
      k1=1                                                                gaupd.1135
  120 if (i1.eq.iact(1,k1)                                                gaupd.1136
     1   .and.n1.ge.iact(2,k1).and.n1.le.iact(3,k1)) go to 130            gaupd.1137
      k1=k1+1                                                             gaupd.1138
      if (k1.le.nact) go to 120                                           gaupd.1139
      call error('first line for delete is not active')                   gaupd.1140
  130 k2=k1                                                               gaupd.1141
  140 if (i2.eq.iact(1,k2)                                                gaupd.1142
     1   .and.n2.ge.iact(2,k2).and.n2.le.iact(3,k2)) go to 150            gaupd.1143
      k2=k2+1                                                             gaupd.1144
      if (k2.le.nact) go to 140                                           gaupd.1145
      call error('second line for delete is not active')                  gaupd.1146
c                                                                         gaupd.1147
c     ***do all the special cases                                         gaupd.1148
  150 if (n1.gt.iact(2,k1)) go to 220                                     gaupd.1149
      if (n2.lt.iact(3,k2)) go to 180                                     gaupd.1150
c                                                                         gaupd.1151
c     ***delete entire blocks                                             gaupd.1152
      m=k2-k1+1                                                           gaupd.1153
      n=nact-k1                                                           gaupd.1154
      if (n.le.0) go to 175                                               gaupd.1155
      do 170 i=1,n                                                        gaupd.1156
      k=k1+i-1                                                            gaupd.1157
      do 160 j=1,3                                                        gaupd.1158
      iact(j,k)=iact(j,k+m)                                               gaupd.1159
  160 continue                                                            gaupd.1160
  170 continue                                                            gaupd.1161
  175 nact=nact-m                                                         gaupd.1162
      if (k1.le.nact) then                                                gaupd.1163
         after=.false.                                                    gaupd.1164
      else                                                                gaupd.1165
         after=.true.                                                     gaupd.1166
         k1=k1-1                                                          gaupd.1167
      endif                                                               gaupd.1168
      go to 350                                                           gaupd.1169
c                                                                         gaupd.1170
c     ***break occurs in second block only                                gaupd.1171
  180 m=k2-k1                                                             gaupd.1172
      n=nact-k1                                                           gaupd.1173
      if (m.eq.0.or.n.eq.0) go to 210                                     gaupd.1174
      do 200 i=1,n                                                        gaupd.1175
      k=k1+i-1                                                            gaupd.1176
      do 190 j=1,3                                                        gaupd.1177
      iact(j,k)=iact(j,k+m)                                               gaupd.1178
  190 continue                                                            gaupd.1179
  200 continue                                                            gaupd.1180
  210 nact=nact-m                                                         gaupd.1181
      iact(2,k1)=n2+1                                                     gaupd.1182
      after=.false.                                                       gaupd.1183
      go to 350                                                           gaupd.1184
c                                                                         gaupd.1185
c     ***break occurs in first block only                                 gaupd.1186
  220 if (k1.ne.k2.or.n2.ne.iact(3,k1)) go to 270                         gaupd.1187
      m=k2-k1                                                             gaupd.1188
      n=nact-k1-1                                                         gaupd.1189
      if (m.eq.0.or.n.eq.0) go to 250                                     gaupd.1190
      do 240 i=1,n                                                        gaupd.1191
      k=k1+i                                                              gaupd.1192
      do 230 j=1,3                                                        gaupd.1193
      iact(j,k)=iact(j,k+m)                                               gaupd.1194
  230 continue                                                            gaupd.1195
  240 continue                                                            gaupd.1196
  250 nact=nact-m                                                         gaupd.1197
      iact(3,k1)=n1-1                                                     gaupd.1198
      after=.true.                                                        gaupd.1199
      go to 350                                                           gaupd.1200
c                                                                         gaupd.1201
c     ***breaks occcur in the middle of different blocks                  gaupd.1202
  270 if (k2.eq.k1) go to 310                                             gaupd.1203
      m=k2-k1-1                                                           gaupd.1204
      if (m.eq.0) go to 300                                               gaupd.1205
      n=nact-k1-m                                                         gaupd.1206
      do 290 i=1,n                                                        gaupd.1207
      k=k1+1+(i-1)                                                        gaupd.1208
      do 280 j=1,3                                                        gaupd.1209
  280 iact(j,k)=iact(j,k+m)                                               gaupd.1210
  290 continue                                                            gaupd.1211
  300 nact=nact-m                                                         gaupd.1212
      iact(3,k1)=n1-1                                                     gaupd.1213
      iact(2,k1+1)=n2+1                                                   gaupd.1214
      after=.true.                                                        gaupd.1215
      go to 350                                                           gaupd.1216
c                                                                         gaupd.1217
c     ***break occurs in the middle of a single block                     gaupd.1218
  310 n=nact-k1                                                           gaupd.1219
      if (n.eq.0) go to 340                                               gaupd.1220
      do 330 i=1,n                                                        gaupd.1221
      k=nact-i+1                                                          gaupd.1222
      do 320 j=1,3                                                        gaupd.1223
      iact(j,k+1)=iact(j,k)                                               gaupd.1224
  320 continue                                                            gaupd.1225
  330 continue                                                            gaupd.1226
  340 nact=nact+1                                                         gaupd.1227
      if (nact.gt.9999)                                                   gaupd.1228
     1   call error('too many active line entries (9999 max)')            gaupd.1229
      iact(1,k1+1)=iact(1,k1)                                             gaupd.1230
      iact(2,k1+1)=n2+1                                                   gaupd.1231
      iact(3,k1+1)=iact(3,k1)                                             gaupd.1232
      iact(3,k1)=n1-1                                                     gaupd.1233
      after=.true.                                                        gaupd.1234
  350 continue                                                            gaupd.1235
c                                                                         gaupd.1236
c     ***insert the additional lines (if any)                             gaupd.1237
      if (iseq.eq.iseq1) return                                           gaupd.1238
      if (after) then                                                     gaupd.1239
         k=iact(1,k1)                                                     gaupd.1240
         id3=id(k)                                                        gaupd.1241
         n3=iact(3,k1)                                                    gaupd.1242
         call insert(id3,n3)                                              gaupd.1243
      else                                                                gaupd.1244
         k=iact(1,k1)                                                     gaupd.1245
         id3=id(k)                                                        gaupd.1246
         n3=iact(2,k1)                                                    gaupd.1247
         call before(id3,n3)                                              gaupd.1248
      endif                                                               gaupd.1249
c                                                                         gaupd.1250
c     ***finished with delete                                             gaupd.1251
      return                                                              gaupd.1252
      end                                                                 gaupd.1253
c                                                                         gaupd.1254
      subroutine insert(id1,n1)                                           gaupd.1255
c     ******************************************************************  gaupd.1256
c     insert lines                                                        gaupd.1257
c     ******************************************************************  gaupd.1258
      character*(*) id1                                                   gaupd.1259
      integer n1                                                          gaupd.1260
      common /upd1/ nid,nact,ndecks                                       gaupd.1261
      common /upd2/ iseq,iseq1                                            gaupd.1262
      common /upd4/ iact(3,9999)                                          gaupd.1263
      character*10 id                                                     gaupd.1264
      common /upd5/ id(1000)                                              gaupd.1265
      common /upd6/ lid(1000)                                             gaupd.1266
c                                                                         gaupd.1267
c     ***check the insert id string                                       gaupd.1268
      i1=0                                                                gaupd.1269
      do 110 i=1,nid                                                      gaupd.1270
      if (id1.eq.id(i)) i1=i                                              gaupd.1271
  110 continue                                                            gaupd.1272
      if (i1.eq.0) call error('unknown identifier for insert')            gaupd.1273
c                                                                         gaupd.1274
c     ***check the insert line number                                     gaupd.1275
      k1=1                                                                gaupd.1276
  120 if (i1.eq.iact(1,k1)                                                gaupd.1277
     1  .and.n1.ge.iact(2,k1).and.n1.le.iact(3,k1)) go to 130             gaupd.1278
      k1=k1+1                                                             gaupd.1279
      if (k1.le.nact) go to 120                                           gaupd.1280
      call error('line is not active for insert')                         gaupd.1281
c                                                                         gaupd.1282
c     ***special case for insert after last line in block                 gaupd.1283
  130 if (n1.lt.iact(3,k1)) go to 170                                     gaupd.1284
      n=nact-k1                                                           gaupd.1285
      if (n.eq.0) go to 160                                               gaupd.1286
      do 150 j=1,n                                                        gaupd.1287
      k=nact-j+1                                                          gaupd.1288
      do 140 l=1,3                                                        gaupd.1289
      iact(l,k+1)=iact(l,k)                                               gaupd.1290
  140 continue                                                            gaupd.1291
  150 continue                                                            gaupd.1292
  160 nact=nact+1                                                         gaupd.1293
      if (nact.gt.9999)                                                   gaupd.1294
     1   call error('too many active line entries (9999 max)')            gaupd.1295
      iact(1,k1+1)=nid                                                    gaupd.1296
      iact(2,k1+1)=iseq1                                                  gaupd.1297
      iact(3,k1+1)=iseq-1                                                 gaupd.1298
      go to 200                                                           gaupd.1299
c                                                                         gaupd.1300
c     ***open up space in the active lines table                          gaupd.1301
c     ***and update the active line entries                               gaupd.1302
  170 n=nact-k1+1                                                         gaupd.1303
      do 190 j=1,n                                                        gaupd.1304
      k=nact-j+1                                                          gaupd.1305
      do 180 l=1,3                                                        gaupd.1306
      iact(l,k+2)=iact(l,k)                                               gaupd.1307
  180 continue                                                            gaupd.1308
  190 continue                                                            gaupd.1309
      nact=nact+2                                                         gaupd.1310
      if (nact.gt.9999)                                                   gaupd.1311
     1   call error('too many active line entries (9999 max)')            gaupd.1312
      iact(1,k1+2)=iact(1,k1)                                             gaupd.1313
      iact(2,k1+2)=n1+1                                                   gaupd.1314
      iact(3,k1+2)=iact(3,k1)                                             gaupd.1315
      iact(1,k1+1)=nid                                                    gaupd.1316
      iact(2,k1+1)=iseq1                                                  gaupd.1317
      iact(3,k1+1)=iseq-1                                                 gaupd.1318
      iact(3,k1)=n1                                                       gaupd.1319
  200 continue                                                            gaupd.1320
c                                                                         gaupd.1321
      return                                                              gaupd.1322
      end                                                                 gaupd.1323
c                                                                         gaupd.1324
      subroutine packl(name,number,label)                                 gaupd.1325
c     ******************************************************************  gaupd.1326
c     pack the name and number into an upd identifier                     gaupd.1327
c     format= <7 chars right justified>.<5 digits left justified>         gaupd.1328
c     ******************************************************************  gaupd.1329
      character*(*) name                                                  gaupd.1330
      integer number                                                      gaupd.1331
      character*(*) label                                                 gaupd.1332
      character*5 num                                                     gaupd.1333
      character*6 blank                                                   gaupd.1334
c                                                                         gaupd.1335
      blank='      '                                                      gaupd.1336
      n=len(name)                                                         gaupd.1337
      do 110 i=1,n                                                        gaupd.1338
      j=i                                                                 gaupd.1339
      if (name(i:i).eq.' ') go to 120                                     gaupd.1340
  110 continue                                                            gaupd.1341
  120 j=j-1                                                               gaupd.1342
      write (num,'(i5)') number                                           gaupd.1343
      do 130 i=1,5                                                        gaupd.1344
      k=i                                                                 gaupd.1345
      if (num(i:i).ne.' ') go to 140                                      gaupd.1346
  130 continue                                                            gaupd.1347
  140 l=7-j                                                               gaupd.1348
      if (l.eq.0) then                                                    gaupd.1349
         label=name(1:7)//'.'//num(k:5)                                   gaupd.1350
      else                                                                gaupd.1351
         label=blank(1:l)//name(1:j)//'.'//num(k:5)                       gaupd.1352
      endif                                                               gaupd.1353
      return                                                              gaupd.1354
      end                                                                 gaupd.1355
c                                                                         gaupd.1356
      subroutine error(mess)                                              gaupd.1357
c     ******************************************************************  gaupd.1358
c     fatal error routine                                                 gaupd.1359
c     ******************************************************************  gaupd.1360
      character*(*) mess                                                  gaupd.1361
      common /upd3/ iupn,iout,jupn,kold                                   gaupd.1362
c                                                                         gaupd.1363
      write (iout,'('' gaupd: fatal error''/                              gaupd.1364
     1   '' gaupd: at upn line number '',i5/                              gaupd.1365
     1   '' gaupd: '',a)') kold,mess                                      gaupd.1366
      stop 480                                                            gaupd.1367
      return                                                              gaupd.1368
      end                                                                 gaupd.1369
c                                                                         gaupd.1370
      character*10 function gettok(iline,idx,nn)                          gaupd.1371
c     ******************************************************************  gaupd.1372
c     get next token from an input line                                   gaupd.1373
c     ******************************************************************  gaupd.1374
      character*72 iline                                                  gaupd.1375
      character*1 ib,ic                                                   gaupd.1376
      data ib,ic/' ',','/                                                 gaupd.1377
c                                                                         gaupd.1378
      do 110 i=idx,nn                                                     gaupd.1379
      if(iline(i:i).ne.ib.and.iline(i:i).ne.ic) go to 120                 gaupd.1380
  110 continue                                                            gaupd.1381
      gettok=' '                                                          gaupd.1382
      return                                                              gaupd.1383
  120 istrt=i                                                             gaupd.1384
      do 130 i=istrt+1,nn                                                 gaupd.1385
      if(iline(i:i).eq.ib.or.iline(i:i).eq.ic) go to 140                  gaupd.1386
  130 continue                                                            gaupd.1387
      gettok=iline(istrt:nn)                                              gaupd.1388
      idx=nn+1                                                            gaupd.1389
      return                                                              gaupd.1390
  140 gettok=iline(istrt:i-1)                                             gaupd.1391
      idx=i+1                                                             gaupd.1392
      return                                                              gaupd.1393
      end                                                                 gaupd.1394
c                                                                         gaupd.1395
      subroutine skipb(iline,j)                                           gaupd.1396
c     ******************************************************************  gaupd.1397
c     skip blanks                                                         gaupd.1398
c     ******************************************************************  gaupd.1399
      character*72 iline                                                  gaupd.1400
      nn=len(iline)                                                       gaupd.1401
      do 110 jj=j,nn                                                      gaupd.1402
      if (iline(jj:jj).eq.' ') go to 110                                  gaupd.1403
      j=jj                                                                gaupd.1404
      return                                                              gaupd.1405
  110 continue                                                            gaupd.1406
      return                                                              gaupd.1407
      end                                                                 gaupd.1408
      subroutine getcd(cdnames,cdid,idid,id1,n1,id2,n2)                   gaupd.1409
c      ***********************************************************        gaupd.1410
c      get index to active list of comdecks for update                    gaupd.1411
c      ***********************************************************        gaupd.1412
      common /upd7/ lcds(500),lcde(500),lcdn(500),ncmdk,jc,jcd,           gaupd.1413
     x iseqs(500),iptcd(100),ncdid,jdx1,jdx2,noid,nlns                    gaupd.1414
      common /upd8/ nupn,ncdu                                             gaupd.1415
      character*10 cdnames(500),id1,id2,cdid(100),idid                    gaupd.1416
      logical noid                                                        gaupd.1417
      jdx1=0                                                              gaupd.1418
      jdx2=0                                                              gaupd.1419
      do 10 i=1,ncmdk                                                     gaupd.1420
      if(id1.eq.cdnames(i))then                                           gaupd.1421
         if(n1.ge.iseqs(i).and.n1.le.iseqs(i)+(lcde(i)-lcds(i)))then      gaupd.1422
            jdx1=i                                                        gaupd.1423
            go to 15                                                      gaupd.1424
         endif                                                            gaupd.1425
      endif                                                               gaupd.1426
 10   continue                                                            gaupd.1427
 15   if(n2.eq.0) return                                                  gaupd.1428
      do 20 i=1,ncmdk                                                     gaupd.1429
      if(id2.eq.cdnames(i))then                                           gaupd.1430
         if(n2.ge.iseqs(i).and.n2.le.iseqs(i)+(lcde(i)-lcds(i)))then      gaupd.1431
           jdx2=i                                                         gaupd.1432
           return                                                         gaupd.1433
         endif                                                            gaupd.1434
      endif                                                               gaupd.1435
 20   continue                                                            gaupd.1436
      return                                                              gaupd.1437
      end                                                                 gaupd.1438
c                                                                         gaupd.1439
      subroutine fixcd(cdnames,cdid,idid,opn,id1,n1,id2,n2,iline)         gaupd.1440
c     ***********************************************************         gaupd.1441
c     fix active lists of comdecks to accomodate updates                  gaupd.1442
c     ***********************************************************         gaupd.1443
      common /upd7/ lcds(500),lcde(500),lcdn(500),ncmdk,jc,jcd,           gaupd.1444
     x iseqs(500),iptcd(100),ncdid,jdx1,jdx2,noid,nlns                    gaupd.1445
      common /upd8/ nupn,ncdu                                             gaupd.1446
      character*10 cdnames(500),id1,id2,cdid(100),opn,idid                gaupd.1447
      character*72 iline                                                  gaupd.1448
      logical noid                                                        gaupd.1449
      isvpt=0                                                             gaupd.1450
 10   m=iseqs(jdx1)                                                       gaupd.1451
      n=m+(lcde(jdx1)-lcds(jdx1))                                         gaupd.1452
 25   if(opn.eq.'*b') then                                                gaupd.1453
         if(n1.eq.m) then                                                 gaupd.1454
c     *** add block before existing blocks                                gaupd.1455
            ncmdk=ncmdk+1                                                 gaupd.1456
            iseqs(ncmdk)=jcd +1                                           gaupd.1457
            call addblk(cdnames,idid,id1,n1,id2,n2,iline)                 gaupd.1458
            if (nlns.eq.0) then                                           gaupd.1459
               ncmdk=ncmdk-1                                              gaupd.1460
               return                                                     gaupd.1461
            endif                                                         gaupd.1462
            do 20 i=1,ncmdk-1                                             gaupd.1463
            if(lcdn(i).eq.jdx1) then                                      gaupd.1464
c     *** fix block that points to this one                               gaupd.1465
               lcdn(ncmdk)=lcdn(i)                                        gaupd.1466
               lcdn(i)=ncmdk                                              gaupd.1467
               return                                                     gaupd.1468
            endif                                                         gaupd.1469
 20         continue                                                      gaupd.1470
c     *** no block pointing to this one so must be first                  gaupd.1471
            do 30 i=1,ncdid                                               gaupd.1472
            if(isvpt.gt.0) then                                           gaupd.1473
               lcdn(ncmdk)=0                                              gaupd.1474
               iptcd(isvpt)=ncmdk                                         gaupd.1475
               return                                                     gaupd.1476
           endif                                                          gaupd.1477
           if(jdx1.eq.iptcd(i)) then                                      gaupd.1478
               lcdn(ncmdk)=jdx1                                           gaupd.1479
               iptcd(i)=ncmdk                                             gaupd.1480
               return                                                     gaupd.1481
            endif                                                         gaupd.1482
 30         continue                                                      gaupd.1483
            call error('cant find comdeck reference')                     gaupd.1484
         endif                                                            gaupd.1485
c      *** add block in middle                                            gaupd.1486
         ncmdk=ncmdk+1                                                    gaupd.1487
         call addblk(cdnames,idid,id1,n1,id2,n2,iline)                    gaupd.1488
         if(nlns.eq.0) then                                               gaupd.1489
            ncmdk=ncmdk-1                                                 gaupd.1490
            return                                                        gaupd.1491
         endif                                                            gaupd.1492
         lcdn(ncmdk+1)=lcdn(jdx1)                                         gaupd.1493
         lcdn(jdx1)=ncmdk                                                 gaupd.1494
         lcdn(ncmdk)=ncmdk+1                                              gaupd.1495
         ncmdk=ncmdk+1                                                    gaupd.1496
         cdnames(ncmdk)=cdnames(jdx1)                                     gaupd.1497
         lcde(ncmdk)=lcde(jdx1)                                           gaupd.1498
         lcde(jdx1)=lcds(jdx1)+(n1-iseqs(jdx1)-1)                         gaupd.1499
         lcds(ncmdk)=(lcde(jdx1)+1)                                       gaupd.1500
         iseqs(jdx1)=n1-1                                                 gaupd.1501
         iseqs(ncmdk)=n1                                                  gaupd.1502
      endif                                                               gaupd.1503
 35   if(opn.eq.'*i') then                                                gaupd.1504
         if(n1.eq.n) then                                                 gaupd.1505
c      *** add block at end of chain                                      gaupd.1506
            ncmdk=ncmdk+1                                                 gaupd.1507
            call addblk(cdnames,idid,id1,n1,id2,n2,iline)                 gaupd.1508
            if(nlns.eq.0) then                                            gaupd.1509
               ncmdk=ncmdk-1                                              gaupd.1510
               return                                                     gaupd.1511
            endif                                                         gaupd.1512
            lcdn(ncmdk)=lcdn(jdx1)                                        gaupd.1513
            lcdn(jdx1)=ncmdk                                              gaupd.1514
            return                                                        gaupd.1515
         endif                                                            gaupd.1516
c      *** add block in middle                                            gaupd.1517
         ncmdk=ncmdk+1                                                    gaupd.1518
         iseqs(ncmdk)=jcd+1                                               gaupd.1519
         call addblk(cdnames,idid,id1,n1,id2,n2,iline)                    gaupd.1520
         if (nlns.eq.0) then                                              gaupd.1521
            ncmdk=ncmdk-1                                                 gaupd.1522
            return                                                        gaupd.1523
         endif                                                            gaupd.1524
         lcdn(ncmdk+1)=lcdn(jdx1)                                         gaupd.1525
         lcdn(jdx1)=ncmdk                                                 gaupd.1526
         lcdn(ncmdk)=ncmdk+1                                              gaupd.1527
         ncmdk=ncmdk+1                                                    gaupd.1528
         cdnames(ncmdk)=cdnames(jdx1)                                     gaupd.1529
         lcde(ncmdk)=lcde(jdx1)                                           gaupd.1530
         lcde(jdx1)=lcds(jdx1)+(n1-iseqs(jdx1))                           gaupd.1531
         lcds(ncmdk)=(lcde(jdx1)+1)                                       gaupd.1532
         iseqs(jdx1)=n1                                                   gaupd.1533
         iseqs(ncmdk)=n1+1                                                gaupd.1534
      endif                                                               gaupd.1535
      if(opn.eq.'*d') then                                                gaupd.1536
         if(jdx1.eq.jdx2) then                                            gaupd.1537
c     *** delete is all in one block                                      gaupd.1538
            num=lcde(jdx1)-lcds(jdx1)                                     gaupd.1539
            if(n1.eq.iseqs(jdx1).and.n2.eq.iseqs(jdx1)+num) then          gaupd.1540
               do 40 i=1,ncmdk                                            gaupd.1541
               if(lcdn(i).eq.jdx1) then                                   gaupd.1542
                  lcdn(i)=lcdn(jdx1)                                      gaupd.1543
                  n=iseqs(i)+(lcdn(i)-lcds(i))                            gaupd.1544
                  m=iseqs(i)                                              gaupd.1545
                  n1=n                                                    gaupd.1546
                  opn='*i'                                                gaupd.1547
                  go to 35                                                gaupd.1548
               endif                                                      gaupd.1549
 40            continue                                                   gaupd.1550
               do 50 i=1,ncdid                                            gaupd.1551
               if(iptcd(i).eq.jdx1) then                                  gaupd.1552
                  isvpt=i                                                 gaupd.1553
                  iptcd(i)=lcdn(jdx1)                                     gaupd.1554
                  n1=iseqs(jdx1)                                          gaupd.1555
                  opn='*b'                                                gaupd.1556
                  go to 25                                                gaupd.1557
               endif                                                      gaupd.1558
 50            continue                                                   gaupd.1559
               call error('cant find comdeck pointer')                    gaupd.1560
            elseif(n1.eq.iseqs(jdx1)) then                                gaupd.1561
                  iseqs(jdx1)=n2+1                                        gaupd.1562
                  lcds(jdx1)=lcds(jdx1)+(n2-n1+1)                         gaupd.1563
                  n1=iseqs(jdx1)                                          gaupd.1564
                  opn='*b'                                                gaupd.1565
                  go to 10                                                gaupd.1566
            elseif(n2.eq.iseqs(jdx1)+num) then                            gaupd.1567
               lcde(jdx1)=lcds(jdx1)+(n1-1-m)                             gaupd.1568
               n1=n1-1                                                    gaupd.1569
               opn='*i'                                                   gaupd.1570
               go to 10                                                   gaupd.1571
            else                                                          gaupd.1572
               lcde(ncmdk+1)=lcde(jdx1)                                   gaupd.1573
               lcde(jdx1)=lcds(jdx1)+(n1-iseqs(jdx1)-1)                   gaupd.1574
               ncmdk=ncmdk+1                                              gaupd.1575
               cdnames(ncmdk)=cdnames(jdx1)                               gaupd.1576
               iseqs(ncmdk)=n2+1                                          gaupd.1577
               lcdn(ncmdk)=lcdn(jdx1)                                     gaupd.1578
               lcdn(jdx1)=ncmdk                                           gaupd.1579
               lcds(ncmdk)=lcde(jdx1)+1+n2-n1+1                           gaupd.1580
               n1=iseqs(ncmdk)                                            gaupd.1581
               opn='*b'                                                   gaupd.1582
               jdx1=ncmdk                                                 gaupd.1583
               go to 10                                                   gaupd.1584
            endif                                                         gaupd.1585
         else                                                             gaupd.1586
c      *** delete spans blocks                                            gaupd.1587
c      *** get rid of full blocks                                         gaupd.1588
            num1=lcde(jdx1)-lcds(jdx1)                                    gaupd.1589
            num2=lcde(jdx2)-lcds(jdx2)                                    gaupd.1590
            j=lcdn(jdx1)                                                  gaupd.1591
 60         if(j.ne.jdx2) then                                            gaupd.1592
               lcdn(jdx1)=lcdn(j)                                         gaupd.1593
               j=lcdn(j)                                                  gaupd.1594
               if(j.eq.0) call error('comdeck chain error')               gaupd.1595
               go to 60                                                   gaupd.1596
            endif                                                         gaupd.1597
            if(n1.eq.iseqs(jdx1)) then                                    gaupd.1598
c      *** delete first block                                             gaupd.1599
               do 70 i=1,ncmdk                                            gaupd.1600
               if(lcdn(i).eq.jdx1) then                                   gaupd.1601
                  if(n2.eq.iseqs(jdx2)+num2) then                         gaupd.1602
                     lcdn(i)=lcdn(jdx2)                                   gaupd.1603
                     jdx1=i                                               gaupd.1604
                     n1=iseqs(i)+(lcdn(i)-lcde(i))                        gaupd.1605
                     go to 10                                             gaupd.1606
                  else                                                    gaupd.1607
                     lcdn(i)=jdx2                                         gaupd.1608
                     iseqs(jdx2)=n2+1                                     gaupd.1609
                     lcds(jdx2)=lcds(jdx2)+n2-iseqs(jdx2)+1               gaupd.1610
                     n1=n2+1                                              gaupd.1611
                     jdx1=jdx2                                            gaupd.1612
                     opn='*b'                                             gaupd.1613
                     go to 10                                             gaupd.1614
                  endif                                                   gaupd.1615
               endif                                                      gaupd.1616
 70            continue                                                   gaupd.1617
               do 80 i=1,ncdid                                            gaupd.1618
               if(iptcd(i).eq.jdx1) then                                  gaupd.1619
                  if(n2.eq.iseqs(jdx2)+num2) then                         gaupd.1620
                    isvpt=i                                               gaupd.1621
                     iptcd(i)=lcdn(jdx2)                                  gaupd.1622
                     jdx1=jdx2                                            gaupd.1623
                     opn='*b'                                             gaupd.1624
                     n1=iseqs(jdx1)                                       gaupd.1625
                     go to 10                                             gaupd.1626
                  else                                                    gaupd.1627
                     iptcd(i)=jdx2                                        gaupd.1628
                     iseqs(jdx2)=n2+1                                     gaupd.1629
                     lcds(jdx2)=lcds(jdx2)+n2-iseqs(jdx2)+1               gaupd.1630
                     jdx1=jdx2                                            gaupd.1631
                     n1=n2+1                                              gaupd.1632
                     opn='*b'                                             gaupd.1633
                     go to 10                                             gaupd.1634
                  endif                                                   gaupd.1635
               endif                                                      gaupd.1636
 80            continue                                                   gaupd.1637
               call error('comdeck chain error')                          gaupd.1638
            else                                                          gaupd.1639
               if(n2.eq.iseqs(jdx2)+num2) then                            gaupd.1640
                  lcdn(jdx1)=lcdn(jdx2)                                   gaupd.1641
                  lcde(jdx1)=lcds(jdx1)+(n1-iseqs(jdx1)-1)                gaupd.1642
                  n1=n1-1                                                 gaupd.1643
                  opn='*i'                                                gaupd.1644
                  n=n1                                                    gaupd.1645
                  go to 35                                                gaupd.1646
               else                                                       gaupd.1647
                  lcde(jdx1)=lcds(jdx1)+(n1-iseqs(jdx1)-1)                gaupd.1648
                  lcdn(jdx1)=jdx2                                         gaupd.1649
                  lcds(jdx2)=lcds(jdx2)+n2-iseqs(jdx2)+1                  gaupd.1650
                  iseqs(jdx2)=n2+1                                        gaupd.1651
                  n1=n1-1                                                 gaupd.1652
                  opn='*i'                                                gaupd.1653
                  n=n1                                                    gaupd.1654
                  go to 35                                                gaupd.1655
               endif                                                      gaupd.1656
           endif                                                          gaupd.1657
        endif                                                             gaupd.1658
      endif                                                               gaupd.1659
      end                                                                 gaupd.1660
      subroutine addblk(cdnames,idid,id1,n1,id2,n2,kline)                 gaupd.1661
c      **********************************************************         gaupd.1662
c      add a block to the active list of comdecks                         gaupd.1663
c      **********************************************************         gaupd.1664
      common /upd3/ iupn,iout,jupn,kold                                   gaupd.1665
      common /upd7/ lcds(500),lcde(500),lcdn(500),ncmdk,jc,jcd,           gaupd.1666
     x iseqs(500),iptcd(100),ncdid,jdx1,jdx2,noid,nlns                    gaupd.1667
      common /upd8/ nupn,ncdu                                             gaupd.1668
      character*10 cdnames(500),idid                                      gaupd.1669
      character*10 id1,id2                                                gaupd.1670
      logical noid                                                        gaupd.1671
      character*72 kline                                                  gaupd.1672
c dwm    changed character*10 to character*13 in following line           gaupd.1673
      character*13 label                                                  gaupd.1674
      lcds(ncmdk)=jc+1                                                    gaupd.1675
      nlns=0                                                              gaupd.1676
      cdnames(ncmdk)=idid                                                 gaupd.1677
 10   read(nupn,'(a)',end=100) kline                                      gaupd.1678
      jupn=jupn+1                                                         gaupd.1679
      if(kline(1:1).eq.'*') then                                          gaupd.1680
         lcde(ncmdk)=jc                                                   gaupd.1681
         return                                                           gaupd.1682
      else                                                                gaupd.1683
         iupn=iupn +1                                                     gaupd.1684
         jc=jc+1                                                          gaupd.1685
         nlns=nlns+1                                                      gaupd.1686
         jcd=jcd+1                                                        gaupd.1687
         if(noid) then                                                    gaupd.1688
            label=' '                                                     gaupd.1689
         else                                                             gaupd.1690
            call packl(idid,jcd,label)                                    gaupd.1691
         endif                                                            gaupd.1692
         write(ncdu,rec=jc) kline,label                                   gaupd.1693
         go to 10                                                         gaupd.1694
      endif                                                               gaupd.1695
 100  lcde(ncmdk)=jc                                                      gaupd.1696
      return                                                              gaupd.1697
      end                                                                 gaupd.1698
c                                                                         mar29.15
c dwm                                                                     mar29.16
      subroutine fixinp (nupn)                                            mar29.17
c     move the contents of nupn to scratch and append a *end card.        mar29.18
c     this enables the proper processing of updates to comdecks.          mar29.19
c                                                                         mar29.20
      character*72 iline                                                  mar29.21
      rewind nupn                                                         mar29.22
      newpn=8                                                             mar29.23
      open (newpn,status='scratch')                                       mar29.24
   10 continue                                                            mar29.25
      read (nupn,'(a)',end=20) iline                                      mar29.26
      write (newpn,'(a)') iline                                           mar29.27
      go to 10                                                            mar29.28
   20 continue                                                            mar29.29
      iline='*end'                                                        mar29.30
      write (newpn,'(a)') iline                                           mar29.31
c                                                                         mar29.32
      close (nupn)                                                        mar29.33
      rewind newpn                                                        mar29.34
      nupn=8                                                              mar29.35
      return                                                              mar29.36
      end                                                                 mar29.37
